Program alberobinario;
Type	binalbero = ^bincella;
	nodo = binalbero;
	bincella = record
		valore : Integer;
		sinistro, destro, genitore : nodo
	End;

Var	albero : binalbero;
var	tmp1, tmp2, tmp3, tmp4, tmp5 : binalbero;

Procedure CreaBinAlbero(Var T: binalbero);
Begin
	T := nil
End;

Function BinAlberoVuoto(Var T:binalbero) : boolean;
Begin
	BinAlberoVuoto := (T = nil)
End;

Function BinRadice(Var T:binalbero) : nodo;
Begin
	BinRadice := T
End;

Function BinPadre(u: nodo; Var T:binalbero) : nodo;
Begin
	BinPadre := u^.genitore;
End;

Function FiglioSinistro(u: nodo; Var T:binalbero) : nodo;
Begin
	FiglioSinistro := u^.sinistro
End;

Function FiglioDestro(u: nodo; Var T:binalbero) : nodo;
Begin
	FiglioDestro := u^.destro
End;

Function SinistroVuoto(u: nodo; Var T:binalbero) : boolean;
Begin
	SinistroVuoto := (u^.sinistro = nil)
End;

Function DestroVuoto(u: nodo; Var T:binalbero) : boolean;
Begin
	DestroVuoto := (u^.destro = nil)
End;

(* concatena due alberi e restituisce in T l'albero risultante *)
Procedure CostrBinAlbero(Var T, U:binalbero; val:integer);
Var w : nodo;
Begin
	new(w);
	w^.sinistro := T;
	w^.destro := U;
	w^.genitore := nil;
	w^.valore := val;
	if T<>nil then T^.genitore:=w;
	if U<>nil then U^.genitore:=w;
	T := w
End;

Procedure BinVisita(u:nodo; Var T:binalbero);
Begin

// prefissa
//	writeln(u^.valore);
	if not SinistroVuoto(u, T) then BinVisita(FiglioSinistro(u, T), T);

// infissa
//	writeln(u^.valore);
	if not DestroVuoto(u, T) then BinVisita(FiglioDestro(u, T), T);

// postfissa
	writeln(u^.valore);

End;

Procedure AllocaNodo(Var T:nodo; val : Integer);
Begin
	new(T);
	T^.valore := val;
	T^.sinistro := NIL;
	T^.destro := NIL;
	T^.genitore := NIL;
End;

Begin
	(* creazione dei nodi foglia *)
	(* nodo 27 *)
	CreaBinAlbero(tmp1);
	AllocaNodo(tmp1, 27);
	(* nodo 31 *)
	CreaBinAlbero(tmp2);
	AllocaNodo(tmp2, 31);
	(* nodo 19 *)
	CreaBinAlbero(tmp3);
	AllocaNodo(tmp3, 19);

	CostrBinAlbero(tmp1, tmp2, 13);
	(* attenzione: cos' cambiato in tmp1 o tmp2? *)

	CreaBinAlbero(tmp4);
	CostrBinAlbero(tmp3, tmp4, 21);
	CostrBinAlbero(tmp1, tmp3, 9);

	albero := tmp1;

	BinVisita(albero, albero);
End.